'=============================================
'Progetto: DDS
'CPU: 18F2550 @ 32MHz (4x8)
'Modulo di controllo LCD (usato da DDS_Main)
'Versione 10.2 - 31/10/11
'Usa il pin R/W del display (pin SDI)
'=============================================

'FUNZIONI ESPOSTE:
'[hello]: menu all'accensione
'[display]: visualizza e aggiorna la pagina parametri
'=============================================


'=======================
'Struttura dati del menu
'=======================

'DEFINIZIONE LABEL E CAMPI:
'#   Y X   LABEL   LEN  X   FIELD     LEN  END
'-   - --  -----   ---  --  -----     --   ---
'1   1 01  'MD:'    3   04  'NORMAL'   6   9
'1   1 01  'MD:'    3   04  'SSWPUP'   6   9
'1   1 01  'MD:'    3   04  'SSWPDN'   6   9
'1   1 01  'MD:'    3   04  'RSWPUP'   6   9
'1   1 01  'MD:'    3   04  'RSWPDN'   6   9
'1   1 01  'MD:'    3   04  'BURST '   6   9


'2   1 10  ' WV:'    -   14  'SIN'      3   16
'2   1 --  ' WV:'    -   14  'TRI'      3   16
'2   1 --  ' WV:'    -   14  'PLS'      3   16

'3   2 01  'FREQ:'  4   06  '12345678' 8   14
'4   3 01  'FSTP:'  5   06  '12345678' 8   14
'5   4 01  'TH:'    3   04  '9999'     4   07
'6   4 08  ' TL:'    3   13  '9999'     4   16

'=============================================


Define LCD_LINES = 4
Define LCD_CHARS = 16
Define LCD_BITS = 4
Define LCD_DREG = PORTA
Define LCD_DBIT = 0
Define LCD_RSREG = PORTA
Define LCD_RSBIT = 5
Define LCD_EREG = PORTA
Define LCD_EBIT = 4

Define LCD_RWREG = PORTC
Define LCD_RWBIT = 4
Define LCD_READ_BUSY_FLAG = 0


'------------------------------

Proc display(md As Byte, wv As Byte)
Dim tmpw As Word
Dim tmpl As Long

Lcdcmdout LcdClear
Lcdout "MD:"

Select Case md
	Case mode_normal
	Lcdout "NORMAL"
	Case mode_sweep_single_up
	Lcdout "SSWPUP"
	Case mode_sweep_single_down
	Lcdout "SSWPDN"
	Case mode_sweep_up
	Lcdout "RSWPUP"
	Case mode_sweep_down
	Lcdout "RSWPDN"
	Case mode_sweep_updown
	Lcdout "RSWPUD"
	Case mode_burst
	Lcdout "BURST "
	Case mode_burst_alt
	Lcdout "BURSTA"
EndSelect

Lcdout "  W:"
Select Case wv
	Case 0
	Lcdout "SIN"
	Case 1
	Lcdout "TRI"
	Case 2
	Lcdout "SQR"
EndSelect


Lcdcmdout LcdLine2Home
tmpl = fld_val(2)
If md > 0 Then
	If md < mode_burst_alt Then
		Lcdout "FLOW:", #tmpl
		Goto skp1
	Endif
Endif
Lcdout "FREQ:", #tmpl


skp1:
Lcdcmdout LcdLine2Pos(15)
Lcdout "Hz"


Lcdcmdout LcdLine3Home
tmpl = fld_val(3)
Select Case md
Case mode_normal
Case mode_burst
Case Else
	Lcdout "FHIG:" #tmpl
	Lcdcmdout LcdLine3Pos(15)
	Lcdout "Hz"
EndSelect

Lcdcmdout LcdLine4Home
If md = mode_normal Then Goto skp3

If md < mode_burst Then
	tmpw = fld_val(4)
	Lcdout "TIME SCAN:", #tmpw, "ms"
	Goto skp3
Endif

tmpw = fld_val(4)
Lcdout "TL:", #tmpw
tmpw = fld_val(5)
Lcdcmdout LcdLine4Pos(10)
Lcdout "TH:", #tmpw


skp3:
		
Call setline(fld_x(cur_field), fld_y(cur_field))

End Proc                                          



hello:
Lcdcmdout LcdClear
Lcdout "* DDS  PROJECT *"
Lcdcmdout LcdLine2Home
Lcdout "  Versione ", #version, ".", #sub_version
Lcdcmdout LcdLine3Home
'Lcdout "Data: ", #vdate
Lcdout "da Alpha Orionis"
Lcdcmdout LcdLine4Home
Lcdout "(Premi un tasto)"
Lcdcmdout LcdCurOff
Return                                            

Proc setline(x As Byte, y As Byte)
Dim tmp As Byte

Select Case y
	Case 1
		Lcdcmdout LcdLine1Pos(x)
	Case 2
		Lcdcmdout LcdLine2Pos(x)
	Case 3
		Lcdcmdout LcdLine3Pos(x)
	Case 4
		Lcdcmdout LcdLine4Pos(x)
	Case Else
EndSelect
End Proc                                          
