'=============================================
'Progetto: DDS
'CPU: 18F2550 @ 32MHz (4x8)
'Modulo FUNCTIONS
'Versione 10.2 - 31/10/11
'Hardware: DDS_18F2550_XTAL ver. 4
'=============================================
Dim _cnt As Byte
Dim _tmp3 As Byte


Proc calcola_frequenza(fq As Long)
Dim tmp As Byte
Dim tmpfq As Long
Dim fq2 As Long  'usata per calcolo freq di comando


'======== NOTA BENE =================
'il moltiplicatore  codificato in SW
'col valore 34, ovvero il valore
'approssimato (33.554432) per un FCLK di 8Mhz.
'Se cambia FCLK occorre modificare il
'segmento che segue

'tmpfq = fq * mult
	fq2 = fq + fq  'x 2
	tmpfq = ShiftLeft(fq, 5)  'x 32
	tmpfq = tmpfq + fq2  'x 2 + x 32 = x 34

	freqlw = tmpfq.LW
	freqhw = tmpfq.HW
	freqhw = ShiftLeft(freqhw, 2)

	If freqlw > 16383 Then
'tmp = freqlw/ 16384
		tmp = ShiftRight(freqlw, 14)
		freqhw = freqhw + tmp
'freqlw= freqlwMod 16384
		freqlw = freqlw And 16383
	Endif

	frq_0 = freqlw.LB
	frq_1 = freqlw.HB
	frq_2 = freqhw.LB
	frq_3 = freqhw.HB

	Gosub spi_send_freq

End Proc                                          


init_dds:
	gen_mode = mode_normal
	wave = wave_tri  'tri
	frq_low = 1000
	frq_hgh = 2000
	time_off = 500
	time_on = 500

	frq = frq_low

	f_inmenu = False
	
	f_keyb_changed = True
	f_freq_changed = False
	f_wave_changed = False
	f_mode_changed = False
	f_cmd_changed = False
	
	f_bytereceived = False
	f_serial_enabled = True
	f_echo_enabled = False
	f_buffering = False
	f_triggering = False
Return                                            


reset_dds:
	ctrl = %00001000
	ctrh = %00000001  'reset=1
	Gosub spi_send_command

	ctrh = %00100001  'B28=1 + hlb=0 + reset=1
	Gosub spi_send_command

	ctrh = %00100000  'B28=1,HLB=0, Reset=0
	Gosub spi_send_command
	
	frq_0 = 0
	frq_1 = 0
	frq_2 = 0
	frq_3 = 0
	Gosub spi_send_freq
Return                                            


'====================================================


cambia_modo:

frq = frq_low
burst_step_cnt = 0
sweep_step_cnt = 0
sweep_delta_freq = frq_hgh - frq_low
sweep_delta_freq = sweep_delta_freq / time_on

f_triggering = False  'disabilita il Trigger

Select Case gen_mode
Case mode_normal

Case mode_burst, mode_burst_alt
	burst_low = False
Case mode_sweep_single_up
	frq = frq_low
Case mode_sweep_single_down
	frq = frq_hgh
Case mode_sweep_up
	frq = frq_low
Case mode_sweep_down
	frq = frq_hgh
Case mode_sweep_updown
	sweep_direction = False
	frq = frq_low
EndSelect

'abilita la generazione del Trigger in qualsiasi modalit
'diversa da Normal
If gen_mode <> mode_normal Then f_triggering = True
Return                                            


cambia_forma:
'hex 2008
'ctrh = %00100000  'B28=1,HLB=0, Reset=0
	ctrl = %00001000  'DIV by 1

	Select Case wave
	Case 0
	Case 1
		High wtri
	Case 2
		High orbit
	Case 3
		High orbit
		Low dv2
	EndSelect

	Gosub spi_send_command

Return                                            


serial_execute:
Disable Low

f_cmd_changed = False

gen_mode = buf(0)
wave = buf(1)
freqhw.HB = buf(2)
freqhw.LB = buf(3)
freqlw.HB = buf(4)
freqlw.LB = buf(5)
frq_low.LW = freqlw
frq_low.HW = freqhw

freqhw.HB = buf(6)
freqhw.LB = buf(7)
freqlw.HB = buf(8)
freqlw.LB = buf(9)
frq_hgh.LW = freqlw
frq_hgh.HW = freqhw

time_off.HB = buf(10)
time_off.LB = buf(11)
time_on.HB = buf(12)
time_on.LB = buf(13)

frq = frq_low

Gosub cambia_forma
Gosub cambia_modo
Call get_values()
Call display(gen_mode, wave)
Call calcola_frequenza(frq)
Gosub save_parameters


Enable Low
Return                                            

save_parameters:
dummyb = INTCON2
INTCON2 = 0  'ferma interrupts
Write 0, version
Write 1, gen_mode
Write 2, wave

ASM:        movff frq_low,frq_0
ASM:        movff frq_low+1,frq_1
ASM:        movff frq_low+2,frq_2
ASM:        movff frq_low+3,frq_3
Write 3, frq_0
Write 4, frq_1
Write 5, frq_2
Write 6, frq_3

ASM:        movff frq_hgh,frq_0
ASM:        movff frq_hgh+1,frq_1
ASM:        movff frq_hgh+2,frq_2
ASM:        movff frq_hgh+3,frq_3
Write 7, frq_0
Write 8, frq_1
Write 9, frq_2
Write 10, frq_3

ASM:        movff time_on,frq_0
ASM:        movff time_on+1,frq_1
ASM:        movff time_off,frq_2
ASM:        movff time_off+1,frq_3
Write 11, frq_0
Write 12, frq_1
Write 13, frq_2
Write 14, frq_3

Write 15, 1
INTCON2 = dummyb
Return                                            

