'=============================================
'Progetto: DDS
'CPU: 18F2550 @ 32MHz (4x8)
'Modulo di controllo LCD (usato da DDS_Main)
'Versione 10.2 - 31/10/11
'Usa il pin R/W del display (pin SDI)
'=============================================

'FUNZIONI ESPOSTE:

'=============================================


'=======================
'Struttura dati del menu
'=======================

'Struct FIELD
'posX
'posY
'maxlen
'digits
'value
'type
'enabled
'end Struct


Const fld_num = 6  'numero di fields nel menu
Const fnum = 5  'numero di fields nel menu-1
Const key_num = 10
Const key_clear = 10
Const key_up = 11
Const key_down = 12
Const key_right = 13
Const key_left = 14
Const key_enter = 15

Dim fld_x(6) As Byte
Dim fld_y(6) As Byte
Dim fld_max(6) As Byte
Dim fld_dgt(6) As Byte
Dim fld_val(6) As Long
Dim fld_type(6) As Byte
Dim fld_ena(6) As Byte

Dim cur_field As Byte  'indice campo attuale
Dim keyb_cmd As Byte

'=============================================


'routine chiamata dal ISR al cambio di stato 0->1 di Press
'ovvero tasto premuto e rilasciato
Proc keyboard()
Dim item_valid As Byte
Dim keyvalue As Byte
Dim tmp_keyb As Long
Dim numdigits As Byte
Dim maxlen As Byte
Dim keyb_value As Long
Dim gmode As Byte
Dim gwav As Byte
Dim parm_changed As Bit

Dim from88 As Byte
'legge in keyvalue il numero di tasto premuto dai bit BCD1..4
ASM:        movf portb,w
ASM:        rrcf wreg,w
ASM:        andlw 0x0f
ASM:        movwf from88
ASM:        addlw LOW codici
ASM:        movwf TBLPTRL
ASM:        clrf TBLPTRU
ASM:        movlw HIGH codici
ASM:        movwf TBLPTRH
ASM:        TBLRD*+
ASM:        movf TABLAT,w
ASM:        movwf keyvalue

'Lcdcmdout LcdClear
'Lcdout #from88, " --> ", #keyvalue
'Exit

'riavvia con i parametri correnti
	If f_initialized = False Then
		f_mode_changed = True
		f_wave_changed = True
		f_freq_changed = True
		f_initialized = True
		Exit
	Endif
	
	If f_inmenu = False Then
		If keyvalue = key_enter Then  'enter
			cur_field = 0
			f_keyb_changed = True
			f_inmenu = True
			Call setline(fld_x(0), fld_y(0))
			Lcdcmdout LcdCurBlink
		Endif
		Exit
	Endif

	item_valid = fld_ena(cur_field)
	
	gmode = fld_val(0)
	gwav = fld_val(1)
	numdigits = fld_dgt(cur_field)
	maxlen = fld_max(cur_field)
	keyb_value = fld_val(cur_field)
	Call setline(fld_x(cur_field), fld_y(cur_field))
	

	Select Case keyvalue
	Case < key_num
		If item_valid > 0 Then  'prosegui solo se in campi numerici

'se questo campo  appena stato raggiunto, azzera il valore corrente,
'altrimenti aggiungi il nuovo valore a quello corrente
			If f_keyb_changed Then
				keyb_value = 0
				numdigits = 0
				f_keyb_changed = False
			Endif
			
			If numdigits < maxlen Then
'= new_keyb_value * 10 + keyvalue
				keyb_value = keyb_value + keyb_value  'x2
				tmp_keyb = keyb_value
				keyb_value = keyb_value + keyb_value  'x4
				keyb_value = keyb_value + keyb_value  'x8
				keyb_value = keyb_value + tmp_keyb  'x10
				keyb_value = keyb_value + keyvalue
				numdigits = numdigits + 1
				fld_dgt(cur_field) = numdigits
				fld_val(cur_field) = keyb_value
				Call display(gmode, gwav)
			Endif
		Endif
								
				
	Case key_clear  'azzera solo i campi numerici
		If fld_type(cur_field) = 1 Then
			keyb_value = 0
			numdigits = 0
			f_keyb_changed = False
			fld_dgt(cur_field) = numdigits
			fld_val(cur_field) = keyb_value
			Call display(gmode, gwav)
		Endif
		
		
	Case key_right
nxtf1:
		cur_field = cur_field + 1
		If cur_field = fld_num Then cur_field = 0
		If fld_ena(cur_field) = 0 Then Goto nxtf1
		Call setline(fld_x(cur_field), fld_y(cur_field))
		f_keyb_changed = True

	
	Case key_left
nxtf2:
		cur_field = cur_field - 1
		If cur_field = 255 Then cur_field = fnum
		If fld_ena(cur_field) = 0 Then Goto nxtf2
		Call setline(fld_x(cur_field), fld_y(cur_field))
		f_keyb_changed = True
		
		
	Case key_enter
		f_mode_changed = True
		f_wave_changed = True
		f_freq_changed = True
	
		Call set_values()
		Lcdcmdout LcdCurOff
		f_inmenu = False
		
		
	Case key_up
		If fld_type(cur_field) = 0 Then  'mode o wave
			If cur_field = 0 Then  'mode
				If keyb_value = mode_num Then
					keyb_value = 0
				Else
					keyb_value = keyb_value + 1
				Endif
				gmode = keyb_value
			Endif
			
			If cur_field = 1 Then  'wave
				If keyb_value = wave_num Then  'square
					keyb_value = 0
				Else
					keyb_value = keyb_value + 1
				Endif
				gwav = keyb_value
			Endif
			
			fld_val(cur_field) = keyb_value
			Call set_mode(gmode)
			Call display(gmode, gwav)
		Endif
		
	Case key_down
		If fld_type(cur_field) = 0 Then  'mode o wave
			If cur_field = 0 Then  'mode
				If keyb_value = 0 Then
					keyb_value = mode_num
				Else
					keyb_value = keyb_value - 1
				Endif
				gmode = keyb_value
			Endif
			If cur_field = 1 Then  'wave
				If keyb_value = 0 Then  'square
					keyb_value = wave_num
				Else
					keyb_value = keyb_value - 1
				Endif
				gwav = keyb_value
			Endif
			
			fld_val(cur_field) = keyb_value
			Call set_mode(gmode)
			Call display(gmode, gwav)
		Endif
		
		
	EndSelect

End Proc                                          

Proc set_values()
	gen_mode = fld_val(0)
	wave = fld_val(1)
	frq_low = fld_val(2)
	frq_hgh = fld_val(3)
	time_off = fld_val(4)
	time_on = fld_val(5)
	frq = frq_low
	
	Gosub save_parameters  'in Functions
End Proc                                          

Proc get_values()
	fld_val(0) = gen_mode
	fld_val(1) = wave
	fld_val(2) = frq_low
	fld_val(3) = frq_hgh
	fld_val(4) = time_off
	fld_val(5) = time_on
End Proc                                          


Proc set_mode(md As Byte)
Dim k As Byte

	Select Case md

	Case mode_normal
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 0, 0, 0), k
		Next k
	Case mode_sweep_single_up
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 0), k
		Next k
	Case mode_sweep_single_down
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 0), k
		Next k
	Case mode_sweep_up
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 0), k
		Next k
	Case mode_sweep_down
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 0), k
		Next k
	Case mode_sweep_updown
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 0), k
		Next k
	Case mode_burst
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 0, 1, 1), k
		Next k
	Case mode_burst_alt
		For k = 0 To fnum
			fld_ena(k) = LookUp(1, 1, 1, 1, 1, 1), k
		Next k
	EndSelect

End Proc                                          


Proc init_menu()
Dim k As Byte

	cur_field = 0
	For k = 0 To fnum
		fld_x(k) = LookUp(4, 14, 6, 6, 4, 13), k
		fld_y(k) = LookUp(1, 1, 2, 3, 4, 4), k
		fld_max(k) = LookUp(1, 1, 8, 8, 4, 4), k
		fld_type(k) = LookUp(0, 0, 1, 1, 1, 1), k
		fld_val(k) = 0
		fld_dgt(k) = 0
	Next k
	
	Call set_mode(gen_mode)
	
End Proc                                          


'Tabella di conversione da codici Keyboard a codici comando

'sequenza di tasti sulla tastiera (da sinistra a destra, dall'alto al basso)
'1,2,3,A
'4,5,6,B
'7,8,9,C
'*,0,#,D

'Codici corrispondenti generati dal modulo Keyboard:
'15,7,11,3
'13,5,9,1
'14,6,10,2
'12,4,8,0

'Tabella di conversione
'ASM:codici: db 13,11,12,10,0,5,8,2,14,6,9,3,15,4,7,1
ASM:codici: db 13,11,12,10,0,5,8,2,14,6,9,3,15,4,7,1
	