'*****************************************
'DDS - modulo gestione porta seriale
'Versione 10.2 - 31/10//
'PIC 18F25x0 @ 4 x 8 MHz(internal clock)
'*****************************************
Dim _tmp1 As Byte
Dim _tmp2 As Byte
Dim dig0 As Byte
Dim dig1 As Byte


serial_cmd:
f_bytereceived = False

If f_buffering Then
	buf(bufptr) = rxbyte
	bufptr = bufptr + 1
	If bufptr = msglen Then
		f_cmd_changed = True
		bufptr = 0
		f_buffering = False
	Endif
	
Else
	f_initialized = True
	If rxbyte > 96 Then rxbyte = rxbyte - 32  'converte in Upper Case
	
	Select Case rxbyte
	Case "B"
		f_buffering = True
	Case "R"
		Gosub init_dds
		Gosub reset_dds
		Gosub cambia_forma
		Gosub cambia_modo
		Call get_values()  'copia i valori dei campi nel menu
		Call display(gen_mode, wave)
	Case "E"
		f_echo_enabled = Not f_echo_enabled
	EndSelect
	
	If f_echo_enabled = True Then
		Call send_byte(rxbyte)  'echo
	Endif
	
Endif

Return                                            

Proc send_byte(b As Byte)
TXSTA.TXEN = 1
TXREG = b
ASM:snb:    nop
ASM:        btfss TXSTA,TRMT
ASM:        bra snb
ASM:        bcf TXSTA,TXEN
End Proc                                          

Proc send_decb(b As Byte)
Call b2d(b)
Call send_byte(dig1)
Call send_byte(dig0)
End Proc                                          

Proc send_decw(bb As Word)
Call send_decb(bb.HB)
Call send_decb(bb.LB)
End Proc                                          

Proc sendh_byte(b As Byte)
Call bin2hex(b)
Call send_byte(dig1)
Call send_byte(dig0)
End Proc                                          

Proc sendh_word(wd As Word)
Call bin2hex(wd.HB)
Call send_byte(dig1)
Call send_byte(dig0)
Call bin2hex(wd.LB)
Call send_byte(dig1)
Call send_byte(dig0)
End Proc                                          

sndcrlf:
Call send_byte(0x0d)
Call send_byte(0x0a)
Return                                            

'=====================================
'Modulo di conversione da 1 byte a 1 byte:
'NOTA: in ingresso WREG contiene il byte da convertire
'in uscita WREG contiene il byte convertito
'- da BIN a BCD

'Modulo di conversione da 1 byte a 2 byte:
'- da BIN a ASCII DEC
'- da BIN a ASCII HEX

'=====================================================


ASM:bin2bcd: movwf _tmp1
ASM:        movlw 0xff
ASM:        movwf _tmp2
ASM:        movlw 10
ASM:bb1:    incf _tmp2,f
ASM:        subwf _tmp1,f
ASM:        btfsc status,c
ASM:        goto bb1
ASM:        addwf _tmp1,w
ASM:        swapf _tmp2,f
ASM:        iorwf _tmp2,w
ASM:        return

'-----------------------------------------------------------
Proc b2d(b As Byte)
WREG = b
ASM:bin2dec: call bin2bcd
ASM:        movwf _tmp1
ASM:        andlw 0x0f
ASM:        addlw "0"
ASM:        movwf dig0
ASM:        swapf _tmp1,w
ASM:        andlw 0x0f
ASM:        addlw "0"
ASM:        movwf dig1
ASM:        Return
End Proc                                          

'------------------------------------------------------------
Proc bin2hex(bb As Byte)
ASM:        movff bb,w
ASM:b2hex:  movwf _tmp1
ASM:        andlw 0xf0
ASM:        movwf _tmp2
ASM:        swapf _tmp2,f
ASM:        movlw 10
ASM:        subwf _tmp2,w
ASM:        btfsc status,c
ASM:        goto ch1
ASM:        addlw 10
ASM:        iorlw 0x30
ASM:        goto ch2
ASM:ch1:    addlw 0x41
ASM:ch2:    movwf dig1

ASM:        movf _tmp1,w
ASM:        andlw 0x0f
ASM:        movwf _tmp2
ASM:        movlw 10
ASM:        subwf _tmp2,w
ASM:        btfsc status,c
ASM:        goto ch3
ASM:        addlw 10
ASM:        iorlw 0x30
ASM:        goto ch4
ASM:ch3:    addlw 0x41
ASM:ch4:    movwf dig0
End Proc                                          


